
(import scheme (chicken base) (chicken condition)
        pseudolists
        simple-tests)

;; set sentinel
(pl-sentinel 0)

(define-checks (basic? verbose?)
  (pl? "x") #t
  (pl? '(a b . c)) #t
  (pl-check-sentinel? '(a b . c)) #f
  (pl-null? 5) #t
  ((pl-of?) "x") #t
  ((pl-of? symbol?) '(a b . #f)) #t

  (pl 0 1 2) '(0 1 2 . 0)
  (pl) 0

  (pl-maker 3) '(0 0 0 . 0)
  (pl-iterate add1 5 0) '(0 1 2 3 4 . 0)

  (pl-tail '(1 2 3 4 . #f)) #f
  (pl-tail '(0 1 2 3 2 . 2)) 2
  
  (pl-length '(0 1 2 3 . 0)) 4

  (pl-head '(0 1 2 3 2 . 0)) '(0 1 2 3 2)
  (pl-head 0) '()
  (pl-head '(0 . 1)) '(0)

  (pl-at 1 '(0 1 2 3 . 4)) 1
  (pl-at 2 '(0 1 2 3 . #f)) 2
  (condition-case (pl-at 0 1)
    ((exn) #f)) #f

  (pl-index odd? '(0 1 2 . 0)) 1
  (pl-index odd? '(0 2 4 . 0)) -1

  (pl-memp odd? '(0 2 4 . 0)) #f
  (pl-memv 5 '(0 1 2 3 4 . 5)) #f
  (pl-member 3 '(0 1 2 3 4 . 5)) '(3 4 . 5)
  )
;(basic?)

(define-checks (higher? verbose?)
  (pl-drop 1 '(0 1 2 3 . 4)) '(1 2 3 . 4)
  (pl-drop 0 1) 1
  (pl-drop 2 '(0 1 2 3 . #f)) '(2 3 . #f)
  (pl-drop-while odd? '(1 3 2 4 . #f)) '(2 4 . #f)
  (pl-drop-while negative? '(1 3 2 4 . #f)) '(1 3 2 4 . #f)
  
  (pl-take 3 '(0 1 2 3 4 . #t)) '(0 1 2 . #t)
  (pl-take 2 '(0 1 2 3 . #f)) '(0 1 . #f)
  (pl-take-while odd? '(1 3 2 4 . #f)) '(1 3 . #f)
  (pl-take-while negative? '(1 3 2 4 . #f)) #f
  (pl-take-while even? '(0 1 2 3 . #f)) '(0 . #f)

  (pl-filter odd? 1) 1
  (pl-filter odd? '(0 1 2 3 4)) '(1 3)
  (pl-filter odd? '(0 1 2 3 . 4)) '(1 3 . 4)
  (pl-filter even? '(0 1 2 3 . 4)) '(0 2 . 4)
  
  (pl-map add1 '(0 1 2 3 . 4)) '(1 2 3 4 . 4)
  (pl-map add1 '(0 1 2 3)) '(1 2 3 4)
  (pl-map add1 #f) #f
  (pl-map + '(1 2 3 . 4) '(10 20 . 30))
    '(11 22 . 30)
  (pl-map + '(1 2 3 . 4) '(10 20 . 30) '(100 200 . 300))
    '(111 222 . 30)

  (pl-reverse '(0 1 2 3 . 4)) '(3 2 1 0 . 4)
  (pl-reverse '(0 1 2 3)) '(3 2 1 0)

  (pl-append '(0 1) #f) '(0 1 . #f)
  (pl-append '(0 1)) '(0 1)
  (pl-append '(0 1) '(2 3) #f) '(0 1 2 3 . #f)
  (pl-append '(0 1 . #f) '(2 3)) '(0 1 2 3)
  (pl-append '(0 1) '(2 3) '(4 5)) '(0 1 2 3 4 5)
  (pl-append '(0 1 . #f) '(2 3 . #t) '(4 5)) '(0 1 2 3 4 5)
  (pl-append '(0 1 . #t) '(2 3 . #t) '(4 5 . #t)) '(0 1 2 3 4 5 . #t)
  (pl-append '(0 1 . #t) '(2 3 . #t) '(4 5) #t) '(0 1 2 3 4 5 . #t)

  (pl-fold-right + 0 '(1 2 3 . #f)) 6
  (pl-fold-left + 0 '(1 2 3)) 6

  (pl-adjoin 2 '(0 1 2 3 . #f)) '(0 1 2 3 . #f)
  (pl-adjoin 4 '(0 1 2 3 #f . #t)) '(4 0 1 2 3 #f . #t)
  (pl-adjoin 1 '(0 1 2 3)) '(0 1 2 3)
  (pl-adjoin 1 #f) '(1 . #f)

  (pl-remove-dups '(0 1 2 3 2 . 2)) '(0 1 3 2 . 2)
  (pl-remove-dups '(0 1 2 3 2 2)) '(0 1 3 2)
  (pl-remove-dups '(0 1 2 1 3 2)) '(0 1 3 2)

  (pl-flatten '(1 (2 3) . #t)) '(1 2 3 . #t)
  (pl-flatten '(1 (2 (3 . #f) . #t) . #f)) '(1 2 3 . #f)
  (pl-flatten '(1 (2 (3 . #f) . #t))) '(1 2 3)
  (pl-flatten #f) #f
  )
;(higher?)
  
(define-checks (collect? verbose?)
  (pl-collect (add1 x) (x '(0 1 2 3 . #f))) ; map
    '(1 2 3 4 . #f)
  (pl-collect (add1 x) (x '(0 1 2 3))) ; map
    '(1 2 3 4)
  (pl-collect x (x '(0 1 2 3 4 5 . #f) (odd? x))) ; filter
    '(1 3 5 . #f)
  (pl-collect x (x '(0 1 2 3 4 5) (odd? x))) ; filter
    '(1 3 5)
  (pl-collect (* 10 n) (n '(0 1 2 3 4 5) (positive? n) (even? n)))
    '(20 40)
  (pl-collect (list c k)
              (c '(A B C))
              (k '(1 2 3 4)))
    '((A 1) (A 2) (A 3) (A 4)
      (B 1) (B 2) (B 3) (B 4)
      (C 1) (C 2) (C 3) (C 4))
  (pl-collect (list c k)
              (c '(A B C . #t))
              (k '(1 2 3 4 . #f)))
    '((A 1) (A 2) (A 3) (A 4)
      (B 1) (B 2) (B 3) (B 4)
      (C 1) (C 2) (C 3) (C 4) . #t)
  )
;(collect?)
 
(check-all PSEUDOLISTS
 (basic?)
 (higher?)
 (collect?)
 )

